<?php
/**
 * @package JS Calendar Event for Joomla! 1.5
 * @version $Id: administrator/components/com_jscalendar/models/jscalendar.php 1.5.7 2010-10-20 19:16:53 $
 * @author JoomlaSeller.com
 * @copyright (C) 2010- JoomlaSeller.com
 *
 * JoomlaSeller Calendar Event is a free software. You may make changes but
 * you may not sell it
 *
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 *
 * jscalendar model for JS Calendar Event component
 * @email webmaster@joomlaseller.com
 *
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

//remove notice msg from lay_out
ini_set('error_reporting',E_ALL ^ E_NOTICE); 

jimport( 'joomla.application.component.model' );

/**
 * JS Calendar Event Model
 *
 */
 
class JSCalendarModelJSCalendar extends JModel{

	/**
	 * Retrieves the event data
	 * @return array Array of objects containing the data from the database
	 */
	function getitems(){ 

		global $mainframe, $option;
		$db 			=& JFactory::getDBO(); 
		$config 		= new JConfig();
		$task 			= JArrayHelper::getValue( $_REQUEST, 'task', '' ); 
		$context		= $option."events";	
		
		$filter_order		= $mainframe->getUserStateFromRequest( $context.'filter_order', 'filter_order', 'ordering', 'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context.'filter_order_Dir', 'filter_order_Dir', 'desc', 'word' );	
		$filter_state 		= $mainframe->getUserStateFromRequest( $context.'filter_state', 'filter_state', '', '' );		
		$search 			= $mainframe->getUserStateFromRequest( $context.'search', 'search', '', 'string' );
		$search 			= JString::strtolower( $search );
				
		$limit 			= intval( $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int' ) );
		$limitstart 	= intval( $mainframe->getUserStateFromRequest( "limitstart", 'limitstart', 0, 'int' ) );
		
		$where = array();
		if ( $search ) {
			$where[] = ' name LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}
		if ( $filter_state ) {
			if ( $filter_state != '' ) {
				$where[] = 'created = "'.$filter_state.'"';
			}
		}
		$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );

		if ($filter_order == 'ordering') {
			$orderby = ' ORDER BY created desc, ordering '. $filter_order_Dir;
		} else {
			$orderby = ' ORDER BY created desc, '. $filter_order .' '. $filter_order_Dir .', ordering';
		}
		
		// Get the total records
		$query = 'SELECT count(*)' 
				.' FROM #__jscalendar_jobs'
				.$where
				.$orderby;
		$db->setQuery($query);
		$total = $db->loadResult();	
		// Make sure there aren't any errors
		if ($db->getErrorNum()) {
			echo $db->getErrorMsg();
			exit;
		}		
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		// Get the limited records
		$query = 'SELECT *' 
				.' FROM #__jscalendar_jobs'
				.$where				
				.$orderby;
		$db->setQuery($query,$pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();	
		// Make sure there aren't any errors
		if ($db->getErrorNum()) {
			echo $db->getErrorMsg();
			exit;
		}		
		
		// created date filter
		// Get the limited records
		$query = 'SELECT created' 
				.' FROM #__jscalendar_jobs'
				.' GROUP BY created'
				.' ORDER BY created DESC';
		$db->setQuery($query);
		$created = $db->loadObjectList();
		// Make sure there aren't any errors
		if ($db->getErrorNum()) {
			echo $db->getErrorMsg();
			exit;
		}		
			
		$putG = array();
		$putG[] = JHTML::_( 'select.option',  '', JText::_('JSC SELECT CREATED DATE'));
		foreach($created as $created_row => $created_value){
			$putG[] = JHTML::_( 'select.option',  $created_value->created, $created_value->created);
		}
		$lists['state']	= JHTML::_('select.genericlist', $putG, 'filter_state', array('class'=>'inputbox', 'size'=>'1', 'onchange'=>'document.adminForm.submit();'),'value','text', isset($filter_state) ? $filter_state : "");
		//$lists['state']	= JHTML::_('grid.state',  $filter_state );
	
		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;
	
		// search filter
		$lists['search']= $search;	

		$return = array("items"=>$rows,"pageNav"=>$pageNav,"lists"=>$lists);
		
		return $return;
	}
	
	/**
	 * save/edit new event
	 *
	 * @return unknown_type
	 */
	function save() {
		global $mainframe;

		//$mosConfig_absolute_path 	= JPATH_ROOT;
		//$mosConfig_live_site 		= JURI :: root();
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );				

		$config 			=& JFactory::getConfig();
		$tzoffset 			= $config->getValue('config.offset');
		$date 				=& JFactory::getDate('', $tzoffset);
		$full_date 			= explode(" ",$date->toMySQL());

		$row 				=& $this->getTable();
		$cid 				= JRequest::getVar( 'id', array(), '', 'array' );
		$created			= JRequest::getVar( 'created', '' );
		$msg 				= array("msg"=>array("message"=>array(),"type"=>array()),"id"=>"");
		JArrayHelper::toInteger($cid, array());

		// is new or not
		$is_new = true;
		if ($cid[0] != 0) {
			$is_new = false;
			$row->load((int) $cid[0]);
		}
		if(!isset($created) || $created == ''){
			$where = " created = '".$full_date[0]."'";			
		}else{
			$where = " created = '".$created."'";
		}		
		$row->ordering = $row->getNextOrder( $where );

		if (!$row->bind( $_POST )) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			return false;
		}

		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			return false;
		}
		
		if(!isset($created) || $created == ''){
			$row->created = $date->toMySQL(); //$full_date[0]!='' ? $full_date[0] : $date->toMySQL();
		}else{
			$row->created = $created;
		}
		
			
		if (!$row->store(true)) {
			$msg["msg"]["message"][]= $row->getError();
			$msg["msg"]["type"][]   = "error";
		}else{
			if($is_new === true){
				$msg["msg"]["message"][] = JText::_("JSC EVENT SUCC ADDED");
				$msg["msg"]["type"][] = "message";				
			}else{
				$msg["msg"]["message"][] = JText::_("JSC EVENT SUCC EDITED");
				$msg["msg"]["type"][] = "message";								
			}
		}

		return $msg;
	}	
	
	/**
	 * delete event
	 *
	 * @return string
	 */
	function delete() {
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );
		$db	=& JFactory::getDBO(); 				
		JArrayHelper::toInteger($cid, array());

		if (count($cid) > 0) {
			$row =& $this->getTable();
			foreach ($cid as $id) {
				$row->delete($id);
			}
			$msg = JText::_("JSC EVENT SUCC DELETED");
		} else {
			JError::raiseError(500, JText::_( 'JSC EVENT SELECT DELETE', true ));
		}
		return $msg;
	}	
	
	/**
	 * get an event for edit
	 * 
	 * (non-PHPdoc)
	 * @see libraries/joomla/application/component/JView#display($tpl)
	 */
	function getitem() {
	
		// Check for request forgeries
		//JRequest::checkToken() or jexit( 'Invalid Token' );	
	
		global $mainframe, $option;

		$db	=& JFactory::getDBO();
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );
		
		if(!empty($cid)){
			JArrayHelper::toInteger($cid, array());		
			
			// array where[]
			$where = array();
			$where[] = " id  = '".$cid[0]."'";
			
			// build query 's where
			$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );		
			
			// get list of category
			$sql = "SELECT * "
			."\n FROM `#__jscalendar_jobs` "
			."\n {$where}";
			$db->setQuery($sql);
			$rows = $db->loadObjectList();
			//generate error msg		
			if ($db->getErrorNum()) {
				echo $db->stderr();
				exit;
			}	
			return $rows[0];
		}else{
			return false;
		}
	}	
	

	/**
	 * publish or unpublish event
	 *
	 * @param integer $state
	 * @return boolean
	 */
	function publish($state) {
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );	
	
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );
		JArrayHelper::toInteger($cid, array());

		if (count($cid) > 0) {
			$row =& $this->getTable();
			foreach ($cid as $id) {
				$row->load($id);
				$row->published = $state;
				$row->store();

				if (!$row->check()) {
					$this->setError($row->getError());
					return false;
				}
				if (!$row->store()) {
					$this->setError($row->getError());
					return false;
				}
			}
		}
		return true;
	}
	
	/**
	 * Method order up(-1)/down(1) an event with one record
	 *
	 * $ordering = int current ordering value
	 * $uid		 = int moved category id
	 * $inc		 = int up(-1)/down(1)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */	
	function order(){
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );	
	
		global $mainframe;
		$db 	=& JFactory::getDBO();

		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		//generate move up or dowm
		$task = JRequest::getCmd('task');
		if ($task == 'orderup') {
			$direction = -1;
		} elseif ($task == 'orderdown') {
			$direction = +1;
		}else{
			$direction = $ordering;
		}
		
		if (isset( $cid[0] ))
		{
			$row = & $this->getTable();
			$row->load( (int) $cid[0] );
			$row->move($direction,' created = "'.$row->created.'"');

			$cache = & JFactory::getCache('com_jscalendar');
			$cache->clean();
		}		

		$msg = JText::_('JSC ORDERING SAVED');

		return $msg;
	}
	
	function saveOrder(){
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );	
	
		global $mainframe;

		// Initialize variables
		$db			= & JFactory::getDBO();

		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$order		= JRequest::getVar( 'order', array (0), 'post', 'array' );
		$total		= count($cid);
		$conditions	= array ();

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($order, array(0));

		// Instantiate an article table object
		$row = & $this->getTable();

		// Update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++)
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError( 500, $db->getErrorMsg() );
					return false;
				}
			}
		}

		$cache = & JFactory::getCache('com_jscalendar');
		$cache->clean();

		$msg = JText::_('JSC ORDERING SAVED');
		return $msg;
	}
}
?>