<?php
/**
 * @package JS Calendar Event for Joomla! 1.5
 * @version $Id: components/com_jscalendar/helpers/helper.php 1.5.7 2010-10-20 19:16:53 $
 * @author JoomlaSeller.com
 * @copyright (C) 2010- JoomlaSeller.com
 *
 * JoomlaSeller Calendar Event is a free software. You may make changes but
 * you may not sell it
 *
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 *
 * jscalendar helper for JS Calendar Event component
 * @email webmaster@joomlaseller.com
 *
 */
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die(); 

//remove notice msg from lay_out
ini_set('error_reporting',E_ALL ^ E_NOTICE); 

jimport('joomla.application.component.model');

class JsCalendarHelpers {

    /*
     * get_week_range accepts numeric $month, $day, and $year values.  
     * It will find the first sunday and the last saturday of the week for the
     * given day, and return them as YYYY-MM-DD HH:MM:SS timestamps
     *
     * @param month: numeric value of the month (01 - 12)
     * @param day  : numeric value of the day (01 - 31)
     * @param year : four-digit value of the year (2008)
     * @return     : array('first' => sunday of week, 'last' => saturday of week);
     */
    function get_week_range($day='', $month='', $year='') {
       // default empties to current values
        if (empty($day)) $day = date('d');
        if (empty($month)) $month = date('m');
        if (empty($year)) $year = date('Y');
		
		$current = date('l', mktime(0,0,0,$month, $day, $year));
		$offset = mktime(0,0,0,$month, $day, $year);
		if($current == 'Monday'){
			$start_week = date('Y-m-d', mktime(0,0,0,$month, $day, $year));
			$end_week 	= date('Y-m-d',strtotime("next Sunday",$offset));
		}elseif($current == 'Sunday'){
			$start_week = date('Y-m-d',strtotime("last Monday",$offset));
			$end_week 	= date('Y-m-d', mktime(0,0,0,$month, $day, $year));
		}else{
			$start_week = date('Y-m-d',strtotime("last Monday",$offset));
			$end_week 	= date('Y-m-d',strtotime("next Sunday",$offset));
		}

        if (!empty($start_week) && !empty($end_week)) {
            return array('first'=>$start_week, 'last'=>$end_week);
        }else{
	        // otherwise there was an error :'( and return current day
            return array('first'=>date('Y-m-d', mktime(0,0,0,$month, $day, $year)), 'last'=>date('Y-m-d', mktime(0,0,0,$month, $day, $year)));
		}
    } 
}
?>